<template>
  <v-container>
    <v-row>
      <v-col cols="12">
        <bids-list :bids="bids" @pay="onPay"/>
      </v-col>
    </v-row>
  </v-container>
</template>

<script lang="ts">

import Vue from "vue";
import Component from "vue-class-component";
import BidsList from "@/components/bids/BidsList.vue";
import { Bid } from "@/domain/entity/bid/Bid";
import { AuthInfoResponse } from "@/domain/response/auth/info/AuthInfoResponse";
import { BidListRequest } from "@/domain/request/bid/BidListRequest";

@Component({
  components: {
    BidsList
  }
})
export default class BidsView extends Vue {
  private get bids (): Bid[] {
    return this.$store.getters['bids/items'];
  }

  private get userId (): string {
    return (this.$store.getters['auth/info'] as AuthInfoResponse|null)?.id || "";
  }

  private async mounted (): Promise<void> {
    await this.$store.dispatch('bids/fetch', { userId: this.userId } as BidListRequest);
  }

  private async onPay (bid: Bid): Promise<void> {
    await this.$store.dispatch('bids/payment', bid.id);
  }
}

</script>

<style scoped>

</style>
